<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-04-23 12:12:12Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 29 Sep 2011 19:14:34 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRAgency extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $agencyID = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $name = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $activityCode = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     */
    public $shortName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $companyInformation = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $emailAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $faxNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $phoneNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $visitCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width
     */
    public $visitFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $visitNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $visitNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $visitStreet = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isLegalEntity = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $isMainAgency = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $bankName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $bankAccountNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 60
     */
    public $bankAccountName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $bankBicCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $bankIbanCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $taxNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $kvkNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $mailingCity = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width
     */
    public $mailingFullAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $mailingNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 10
     */
    public $mailingNumberSuffix = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $mailingStreet = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $visitPostalCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 30
     */
    public $mailingPostalCode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRAgency
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRAgency")
     * @mandatory 0
     * @destination-entity CRAgency
     * @to-many 0
     * @name parent
     */
    public $parent = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAgency")
     * @mandatory 0
     * @destination-entity CRAgency
     * @to-many 1
     * @name children
     */
    public $children = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 1
     * @name users
     */
    public $users = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAttachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toVisitCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default 1
     * @nodeType Land
     */
    public $toVisitCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toVisitProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default 1
     * @nodeType Regio
     */
    public $toVisitProvinceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toLanguageNode
     * @qualifier ((typeID = 31) or (typeID = 0))
     * @default 1
     * @nodeType Taal
     */
    public $toLanguageNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toMailingCountryNode
     * @qualifier ((typeID = 11) or (typeID = 0))
     * @default
     * @nodeType Land
     */
    public $toMailingCountryNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toMailingProvinceNode
     * @qualifier ((typeID = 10) or (typeID = 0))
     * @default
     * @nodeType Regio
     */
    public $toMailingProvinceNode = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("agencyID");
        $entityConfiguration->setName("CRAgency");
    }

    /**
     * Set agencyID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setAgencyID($value)
    {
        $this->agencyID = $value;
        return $this;
    }

    /**
     * Get agencyID.
     *
     * @return integer
     */
    public function getAgencyID()
    {
        return $this->agencyID;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set name.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setName($value)
    {
        $this->name = $value;
        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set activityCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setActivityCode($value)
    {
        $this->activityCode = $value;
        return $this;
    }

    /**
     * Get activityCode.
     *
     * @return string
     */
    public function getActivityCode()
    {
        return $this->activityCode;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set shortName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setShortName($value)
    {
        $this->shortName = $value;
        return $this;
    }

    /**
     * Get shortName.
     *
     * @return string
     */
    public function getShortName()
    {
        return $this->shortName;
    }

    /**
     * Set companyInformation.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setCompanyInformation($value)
    {
        $this->companyInformation = $value;
        return $this;
    }

    /**
     * Get companyInformation.
     *
     * @return string
     */
    public function getCompanyInformation()
    {
        return $this->companyInformation;
    }

    /**
     * Set emailAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setEmailAddress($value)
    {
        $this->emailAddress = $value;
        return $this;
    }

    /**
     * Get emailAddress.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * Set faxNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setFaxNumber($value)
    {
        $this->faxNumber = $value;
        return $this;
    }

    /**
     * Get faxNumber.
     *
     * @return string
     */
    public function getFaxNumber()
    {
        return $this->faxNumber;
    }

    /**
     * Set phoneNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setPhoneNumber($value)
    {
        $this->phoneNumber = $value;
        return $this;
    }

    /**
     * Get phoneNumber.
     *
     * @return string
     */
    public function getPhoneNumber()
    {
        return $this->phoneNumber;
    }

    /**
     * Set visitCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitCity($value)
    {
        $this->visitCity = $value;
        return $this;
    }

    /**
     * Get visitCity.
     *
     * @return string
     */
    public function getVisitCity()
    {
        return $this->visitCity;
    }

    /**
     * Set visitFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitFullAddress($value)
    {
        $this->visitFullAddress = $value;
        return $this;
    }

    /**
     * Get visitFullAddress.
     *
     * @return string
     */
    public function getVisitFullAddress()
    {
        return $this->visitFullAddress;
    }

    /**
     * Set visitNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitNumber($value)
    {
        $this->visitNumber = $value;
        return $this;
    }

    /**
     * Get visitNumber.
     *
     * @return string
     */
    public function getVisitNumber()
    {
        return $this->visitNumber;
    }

    /**
     * Set visitNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitNumberSuffix($value)
    {
        $this->visitNumberSuffix = $value;
        return $this;
    }

    /**
     * Get visitNumberSuffix.
     *
     * @return string
     */
    public function getVisitNumberSuffix()
    {
        return $this->visitNumberSuffix;
    }

    /**
     * Set visitStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitStreet($value)
    {
        $this->visitStreet = $value;
        return $this;
    }

    /**
     * Get visitStreet.
     *
     * @return string
     */
    public function getVisitStreet()
    {
        return $this->visitStreet;
    }

    /**
     * Set isLegalEntity.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setIsLegalEntity($value)
    {
        $this->isLegalEntity = $value;
        return $this;
    }

    /**
     * Get isLegalEntity.
     *
     * @return integer
     */
    public function getIsLegalEntity()
    {
        return $this->isLegalEntity;
    }

    /**
     * Set isMainAgency.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setIsMainAgency($value)
    {
        $this->isMainAgency = $value;
        return $this;
    }

    /**
     * Get isMainAgency.
     *
     * @return integer
     */
    public function getIsMainAgency()
    {
        return $this->isMainAgency;
    }

    /**
     * Set bankName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setBankName($value)
    {
        $this->bankName = $value;
        return $this;
    }

    /**
     * Get bankName.
     *
     * @return string
     */
    public function getBankName()
    {
        return $this->bankName;
    }

    /**
     * Set bankAccountNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setBankAccountNumber($value)
    {
        $this->bankAccountNumber = $value;
        return $this;
    }

    /**
     * Get bankAccountNumber.
     *
     * @return string
     */
    public function getBankAccountNumber()
    {
        return $this->bankAccountNumber;
    }

    /**
     * Set bankAccountName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setBankAccountName($value)
    {
        $this->bankAccountName = $value;
        return $this;
    }

    /**
     * Get bankAccountName.
     *
     * @return string
     */
    public function getBankAccountName()
    {
        return $this->bankAccountName;
    }

    /**
     * Set bankBicCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setBankBicCode($value)
    {
        $this->bankBicCode = $value;
        return $this;
    }

    /**
     * Get bankBicCode.
     *
     * @return string
     */
    public function getBankBicCode()
    {
        return $this->bankBicCode;
    }

    /**
     * Set bankIbanCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setBankIbanCode($value)
    {
        $this->bankIbanCode = $value;
        return $this;
    }

    /**
     * Get bankIbanCode.
     *
     * @return string
     */
    public function getBankIbanCode()
    {
        return $this->bankIbanCode;
    }

    /**
     * Set taxNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setTaxNumber($value)
    {
        $this->taxNumber = $value;
        return $this;
    }

    /**
     * Get taxNumber.
     *
     * @return string
     */
    public function getTaxNumber()
    {
        return $this->taxNumber;
    }

    /**
     * Set kvkNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setKvkNumber($value)
    {
        $this->kvkNumber = $value;
        return $this;
    }

    /**
     * Get kvkNumber.
     *
     * @return string
     */
    public function getKvkNumber()
    {
        return $this->kvkNumber;
    }

    /**
     * Set mailingCity.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingCity($value)
    {
        $this->mailingCity = $value;
        return $this;
    }

    /**
     * Get mailingCity.
     *
     * @return string
     */
    public function getMailingCity()
    {
        return $this->mailingCity;
    }

    /**
     * Set mailingFullAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingFullAddress($value)
    {
        $this->mailingFullAddress = $value;
        return $this;
    }

    /**
     * Get mailingFullAddress.
     *
     * @return string
     */
    public function getMailingFullAddress()
    {
        return $this->mailingFullAddress;
    }

    /**
     * Set mailingNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingNumber($value)
    {
        $this->mailingNumber = $value;
        return $this;
    }

    /**
     * Get mailingNumber.
     *
     * @return string
     */
    public function getMailingNumber()
    {
        return $this->mailingNumber;
    }

    /**
     * Set mailingNumberSuffix.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingNumberSuffix($value)
    {
        $this->mailingNumberSuffix = $value;
        return $this;
    }

    /**
     * Get mailingNumberSuffix.
     *
     * @return string
     */
    public function getMailingNumberSuffix()
    {
        return $this->mailingNumberSuffix;
    }

    /**
     * Set mailingStreet.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingStreet($value)
    {
        $this->mailingStreet = $value;
        return $this;
    }

    /**
     * Get mailingStreet.
     *
     * @return string
     */
    public function getMailingStreet()
    {
        return $this->mailingStreet;
    }

    /**
     * Set visitPostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setVisitPostalCode($value)
    {
        $this->visitPostalCode = $value;
        return $this;
    }

    /**
     * Get visitPostalCode.
     *
     * @return string
     */
    public function getVisitPostalCode()
    {
        return $this->visitPostalCode;
    }

    /**
     * Set mailingPostalCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setMailingPostalCode($value)
    {
        $this->mailingPostalCode = $value;
        return $this;
    }

    /**
     * Get mailingPostalCode.
     *
     * @return string
     */
    public function getMailingPostalCode()
    {
        return $this->mailingPostalCode;
    }

    /**
     * Set parent.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRAgency $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setParent($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRAgency($value); 
        }                 
        $this->parent = $value;
        return $this;
    }

    /**
     * Get parent.
     *
     * @return Carerix_Api_Rest_Entity_CRAgency
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Set children.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setChildren($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAgency'); 
        } 
        $this->children = $values;
        return $this;
    }

    /**
     * Get children.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAgency
     */
    public function getChildren($index = null)
    {
        if($index !== null) {
            return $this->children[$index];
        }
        return $this->children;
    }

    /**
     * Set users.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setUsers($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRUser'); 
        } 
        $this->users = $values;
        return $this;
    }

    /**
     * Get users.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRUser
     */
    public function getUsers($index = null)
    {
        if($index !== null) {
            return $this->users[$index];
        }
        return $this->users;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAttachment'); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAttachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toVisitCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setToVisitCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toVisitCountryNode = $value;
        return $this;
    }

    /**
     * Get toVisitCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToVisitCountryNode()
    {
        return $this->toVisitCountryNode;
    }

    /**
     * Set toVisitProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setToVisitProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toVisitProvinceNode = $value;
        return $this;
    }

    /**
     * Get toVisitProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToVisitProvinceNode()
    {
        return $this->toVisitProvinceNode;
    }

    /**
     * Set toLanguageNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setToLanguageNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toLanguageNode = $value;
        return $this;
    }

    /**
     * Get toLanguageNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToLanguageNode()
    {
        return $this->toLanguageNode;
    }

    /**
     * Set toMailingCountryNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setToMailingCountryNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toMailingCountryNode = $value;
        return $this;
    }

    /**
     * Get toMailingCountryNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToMailingCountryNode()
    {
        return $this->toMailingCountryNode;
    }

    /**
     * Set toMailingProvinceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRAgency
     */
    public function setToMailingProvinceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toMailingProvinceNode = $value;
        return $this;
    }

    /**
     * Get toMailingProvinceNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToMailingProvinceNode()
    {
        return $this->toMailingProvinceNode;
    }


}