<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-04-23 12:12:12Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 29 Sep 2011 19:14:50 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRInvoice extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $invoiceID = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 1
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $number = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $date = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $companyName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 255
     */
    public $attention = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000
     */
    public $address = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $total = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $senderBankAccountName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $senderBankAccountNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $senderBankBicCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $senderBankIbanCode = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $senderBankName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $senderName = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $senderKvkNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $senderTaxNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000
     */
    public $senderAddress = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $subject = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $taxPercentage = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 100
     */
    public $paymentPeriod = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 40
     */
    public $currency = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 128
     */
    public $customerReference = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $credited = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $purchaseTotal = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $header = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $footer = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $valueDate = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusNode
     * @qualifier ((typeID = 185) or (typeID = 0))
     * @default 1
     * @nodeType Factuur-status
     */
    public $toStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRInvoiceLine")
     * @mandatory 0
     * @destination-entity CRInvoiceLine
     * @to-many 1
     * @name invoiceLines
     */
    public $invoiceLines = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toContact
     */
    public $toContact = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAttachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRVacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRVacancy")
     * @mandatory 0
     * @destination-entity CRVacancy
     * @to-many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRJob
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRJob")
     * @mandatory 0
     * @destination-entity CRJob
     * @to-many 0
     * @name toJob
     */
    public $toJob = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRPublication
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRPublication")
     * @mandatory 0
     * @destination-entity CRPublication
     * @to-many 0
     * @name toPublication
     */
    public $toPublication = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRAgency
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRAgency")
     * @mandatory 0
     * @destination-entity CRAgency
     * @to-many 0
     * @name agency
     */
    public $agency = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRToDo")
     * @mandatory 0
     * @destination-entity CRToDo
     * @to-many 1
     * @name todos
     */
    public $todos = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRCompany
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRCompany")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toCompany
     */
    public $toCompany = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAttributeChange")
     * @mandatory 0
     * @destination-entity CRAttributeChange
     * @to-many 1
     * @name attributeChanges
     * @qualifier (attributeEntityName = 'CRInvoice')
     */
    public $attributeChanges = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRInvoice
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRInvoice")
     * @mandatory 0
     * @destination-entity CRInvoice
     * @to-many 0
     * @name toCreditInvoice
     */
    public $toCreditInvoice = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("invoiceID");
        $entityConfiguration->setName("CRInvoice");
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set invoiceID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setInvoiceID($value)
    {
        $this->invoiceID = $value;
        return $this;
    }

    /**
     * Get invoiceID.
     *
     * @return integer
     */
    public function getInvoiceID()
    {
        return $this->invoiceID;
    }

    /**
     * Set number.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setNumber($value)
    {
        $this->number = $value;
        return $this;
    }

    /**
     * Get number.
     *
     * @return integer
     */
    public function getNumber()
    {
        return $this->number;
    }

    /**
     * Set date.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setDate($value)
    {
        $this->date = $value;
        return $this;
    }

    /**
     * Get date.
     *
     * @return string
     */
    public function getDate()
    {
        return $this->date;
    }

    /**
     * Set companyName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCompanyName($value)
    {
        $this->companyName = $value;
        return $this;
    }

    /**
     * Get companyName.
     *
     * @return string
     */
    public function getCompanyName()
    {
        return $this->companyName;
    }

    /**
     * Set attention.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setAttention($value)
    {
        $this->attention = $value;
        return $this;
    }

    /**
     * Get attention.
     *
     * @return string
     */
    public function getAttention()
    {
        return $this->attention;
    }

    /**
     * Set address.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setAddress($value)
    {
        $this->address = $value;
        return $this;
    }

    /**
     * Get address.
     *
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Set total.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setTotal($value)
    {
        $this->total = $value;
        return $this;
    }

    /**
     * Get total.
     *
     * @return float
     */
    public function getTotal()
    {
        return $this->total;
    }

    /**
     * Set senderBankAccountName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderBankAccountName($value)
    {
        $this->senderBankAccountName = $value;
        return $this;
    }

    /**
     * Get senderBankAccountName.
     *
     * @return string
     */
    public function getSenderBankAccountName()
    {
        return $this->senderBankAccountName;
    }

    /**
     * Set senderBankAccountNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderBankAccountNumber($value)
    {
        $this->senderBankAccountNumber = $value;
        return $this;
    }

    /**
     * Get senderBankAccountNumber.
     *
     * @return string
     */
    public function getSenderBankAccountNumber()
    {
        return $this->senderBankAccountNumber;
    }

    /**
     * Set senderBankBicCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderBankBicCode($value)
    {
        $this->senderBankBicCode = $value;
        return $this;
    }

    /**
     * Get senderBankBicCode.
     *
     * @return string
     */
    public function getSenderBankBicCode()
    {
        return $this->senderBankBicCode;
    }

    /**
     * Set senderBankIbanCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderBankIbanCode($value)
    {
        $this->senderBankIbanCode = $value;
        return $this;
    }

    /**
     * Get senderBankIbanCode.
     *
     * @return string
     */
    public function getSenderBankIbanCode()
    {
        return $this->senderBankIbanCode;
    }

    /**
     * Set senderBankName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderBankName($value)
    {
        $this->senderBankName = $value;
        return $this;
    }

    /**
     * Get senderBankName.
     *
     * @return string
     */
    public function getSenderBankName()
    {
        return $this->senderBankName;
    }

    /**
     * Set senderName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderName($value)
    {
        $this->senderName = $value;
        return $this;
    }

    /**
     * Get senderName.
     *
     * @return string
     */
    public function getSenderName()
    {
        return $this->senderName;
    }

    /**
     * Set senderKvkNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderKvkNumber($value)
    {
        $this->senderKvkNumber = $value;
        return $this;
    }

    /**
     * Get senderKvkNumber.
     *
     * @return string
     */
    public function getSenderKvkNumber()
    {
        return $this->senderKvkNumber;
    }

    /**
     * Set senderTaxNumber.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderTaxNumber($value)
    {
        $this->senderTaxNumber = $value;
        return $this;
    }

    /**
     * Get senderTaxNumber.
     *
     * @return string
     */
    public function getSenderTaxNumber()
    {
        return $this->senderTaxNumber;
    }

    /**
     * Set senderAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSenderAddress($value)
    {
        $this->senderAddress = $value;
        return $this;
    }

    /**
     * Get senderAddress.
     *
     * @return string
     */
    public function getSenderAddress()
    {
        return $this->senderAddress;
    }

    /**
     * Set subject.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setSubject($value)
    {
        $this->subject = $value;
        return $this;
    }

    /**
     * Get subject.
     *
     * @return string
     */
    public function getSubject()
    {
        return $this->subject;
    }

    /**
     * Set taxPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setTaxPercentage($value)
    {
        $this->taxPercentage = $value;
        return $this;
    }

    /**
     * Get taxPercentage.
     *
     * @return float
     */
    public function getTaxPercentage()
    {
        return $this->taxPercentage;
    }

    /**
     * Set paymentPeriod.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setPaymentPeriod($value)
    {
        $this->paymentPeriod = $value;
        return $this;
    }

    /**
     * Get paymentPeriod.
     *
     * @return string
     */
    public function getPaymentPeriod()
    {
        return $this->paymentPeriod;
    }

    /**
     * Set currency.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCurrency($value)
    {
        $this->currency = $value;
        return $this;
    }

    /**
     * Get currency.
     *
     * @return string
     */
    public function getCurrency()
    {
        return $this->currency;
    }

    /**
     * Set customerReference.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCustomerReference($value)
    {
        $this->customerReference = $value;
        return $this;
    }

    /**
     * Get customerReference.
     *
     * @return string
     */
    public function getCustomerReference()
    {
        return $this->customerReference;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set credited.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCredited($value)
    {
        $this->credited = $value;
        return $this;
    }

    /**
     * Get credited.
     *
     * @return integer
     */
    public function getCredited()
    {
        return $this->credited;
    }

    /**
     * Set purchaseTotal.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setPurchaseTotal($value)
    {
        $this->purchaseTotal = $value;
        return $this;
    }

    /**
     * Get purchaseTotal.
     *
     * @return float
     */
    public function getPurchaseTotal()
    {
        return $this->purchaseTotal;
    }

    /**
     * Set header.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setHeader($value)
    {
        $this->header = $value;
        return $this;
    }

    /**
     * Get header.
     *
     * @return string
     */
    public function getHeader()
    {
        return $this->header;
    }

    /**
     * Set footer.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setFooter($value)
    {
        $this->footer = $value;
        return $this;
    }

    /**
     * Get footer.
     *
     * @return string
     */
    public function getFooter()
    {
        return $this->footer;
    }

    /**
     * Set valueDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setValueDate($value)
    {
        $this->valueDate = $value;
        return $this;
    }

    /**
     * Get valueDate.
     *
     * @return string
     */
    public function getValueDate()
    {
        return $this->valueDate;
    }

    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set invoiceLines.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setInvoiceLines($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRInvoiceLine'); 
        } 
        $this->invoiceLines = $values;
        return $this;
    }

    /**
     * Get invoiceLines.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRInvoiceLine
     */
    public function getInvoiceLines($index = null)
    {
        if($index !== null) {
            return $this->invoiceLines[$index];
        }
        return $this->invoiceLines;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set toContact.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToContact($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->toContact = $value;
        return $this;
    }

    /**
     * Get toContact.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getToContact()
    {
        return $this->toContact;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAttachment'); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAttachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRVacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRVacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_CRVacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set toJob.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRJob $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToJob($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRJob($value); 
        }                 
        $this->toJob = $value;
        return $this;
    }

    /**
     * Get toJob.
     *
     * @return Carerix_Api_Rest_Entity_CRJob
     */
    public function getToJob()
    {
        return $this->toJob;
    }

    /**
     * Set toPublication.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRPublication $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToPublication($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRPublication($value); 
        }                 
        $this->toPublication = $value;
        return $this;
    }

    /**
     * Get toPublication.
     *
     * @return Carerix_Api_Rest_Entity_CRPublication
     */
    public function getToPublication()
    {
        return $this->toPublication;
    }

    /**
     * Set agency.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRAgency $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setAgency($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRAgency($value); 
        }                 
        $this->agency = $value;
        return $this;
    }

    /**
     * Get agency.
     *
     * @return Carerix_Api_Rest_Entity_CRAgency
     */
    public function getAgency()
    {
        return $this->agency;
    }

    /**
     * Set todos.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setTodos($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRToDo'); 
        } 
        $this->todos = $values;
        return $this;
    }

    /**
     * Get todos.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRToDo
     */
    public function getTodos($index = null)
    {
        if($index !== null) {
            return $this->todos[$index];
        }
        return $this->todos;
    }

    /**
     * Set toCompany.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRCompany $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToCompany($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRCompany($value); 
        }                 
        $this->toCompany = $value;
        return $this;
    }

    /**
     * Get toCompany.
     *
     * @return Carerix_Api_Rest_Entity_CRCompany
     */
    public function getToCompany()
    {
        return $this->toCompany;
    }

    /**
     * Set attributeChanges.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setAttributeChanges($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAttributeChange'); 
        } 
        $this->attributeChanges = $values;
        return $this;
    }

    /**
     * Get attributeChanges.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAttributeChange
     */
    public function getAttributeChanges($index = null)
    {
        if($index !== null) {
            return $this->attributeChanges[$index];
        }
        return $this->attributeChanges;
    }

    /**
     * Set toCreditInvoice.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRInvoice $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoice
     */
    public function setToCreditInvoice($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRInvoice($value); 
        }                 
        $this->toCreditInvoice = $value;
        return $this;
    }

    /**
     * Get toCreditInvoice.
     *
     * @return Carerix_Api_Rest_Entity_CRInvoice
     */
    public function getToCreditInvoice()
    {
        return $this->toCreditInvoice;
    }


}