<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-04-23 12:12:12Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 29 Sep 2011 19:14:50 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type i
     * @value-type-human long integer (32 bits)
     */
    public $invoiceLineID = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $info = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $amount = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $numberOfTimes = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $discountPercentage = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $total = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $monNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $tueNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $wedNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $thuNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $friNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $satNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $sunNumber = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $weekTotalNumber = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width
     */
    public $unit = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $invoicingDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $invoicingConditions = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 1
     */
    public $serviceDate = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 1
     */
    public $purchaseAmount = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $showPurchaseInvoiceDetails = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $purchaseNotes = null;

    /**
     * @access private
     * @var string
     * @value-class NSString
     * @allows-null 1
     * @width 1000000
     */
    public $purchaseDescription = null;

    /**
     * @access private
     * @var integer
     * @value-class NSNumber
     * @allows-null 0
     * @value-type s
     * @value-type-human short integer (16 bits)
     */
    public $credited = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toStatusNode
     * @qualifier ((typeID = 183) or (typeID = 0))
     * @default 1
     * @nodeType Factuurregel-status
     */
    public $toStatusNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRWeekHour
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRWeekHour")
     * @mandatory 0
     * @destination-entity CRWeekHour
     * @to-many 0
     * @name toWeekHour
     */
    public $toWeekHour = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRInvoice
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRInvoice")
     * @mandatory 0
     * @destination-entity CRInvoice
     * @to-many 0
     * @name toInvoice
     */
    public $toInvoice = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toServiceNode
     * @qualifier ((typeID = 181) or (typeID = 0))
     * @default 1
     * @nodeType Dienst
     */
    public $toServiceNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCurrencyNode
     * @qualifier ((typeID = 84) or (typeID = 0))
     * @default 1
     * @nodeType Valuta
     */
    public $toCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRVacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRVacancy")
     * @mandatory 0
     * @destination-entity CRVacancy
     * @to-many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRPublication
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRPublication")
     * @mandatory 0
     * @destination-entity CRPublication
     * @to-many 0
     * @name toPublication
     */
    public $toPublication = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAttachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRJob
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRJob")
     * @mandatory 0
     * @destination-entity CRJob
     * @to-many 0
     * @name toJob
     */
    public $toJob = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRToDo")
     * @mandatory 0
     * @destination-entity CRToDo
     * @to-many 1
     * @name todos
     */
    public $todos = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRWeekHourJobView
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRWeekHourJobView")
     * @mandatory 0
     * @destination-entity CRWeekHourJobView
     * @to-many 0
     * @name toWeekHourJobView
     */
    public $toWeekHourJobView = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CREmployee
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CREmployee")
     * @mandatory 0
     * @destination-entity CREmployee
     * @to-many 0
     * @name toEmployee
     */
    public $toEmployee = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRToDo
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRToDo")
     * @mandatory 0
     * @destination-entity CRToDo
     * @to-many 0
     * @name toToDo
     */
    public $toToDo = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRCompany
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRCompany")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toCompany
     */
    public $toCompany = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toInvoicingConditionNode
     */
    public $toInvoicingConditionNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRPurchaseInvoice")
     * @mandatory 0
     * @destination-entity CRPurchaseInvoice
     * @to-many 1
     * @name purchaseInvoices
     */
    public $purchaseInvoices = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRCompany
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRCompany")
     * @mandatory 0
     * @destination-entity CRCompany
     * @to-many 0
     * @name toSupplier
     */
    public $toSupplier = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination-entity CRUser
     * @to-many 0
     * @name toSupplierContact
     */
    public $toSupplierContact = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toPurchaseCurrencyNode
     */
    public $toPurchaseCurrencyNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRFinance
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRFinance")
     * @mandatory 0
     * @destination-entity CRFinance
     * @to-many 0
     * @name toFinance
     */
    public $toFinance = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRInvoiceLine
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRInvoiceLine")
     * @mandatory 0
     * @destination-entity CRInvoiceLine
     * @to-many 0
     * @name toCreditInvoiceLine
     */
    public $toCreditInvoiceLine = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("invoiceLineID");
        $entityConfiguration->setName("CRInvoiceLine");
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set invoiceLineID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setInvoiceLineID($value)
    {
        $this->invoiceLineID = $value;
        return $this;
    }

    /**
     * Get invoiceLineID.
     *
     * @return integer
     */
    public function getInvoiceLineID()
    {
        return $this->invoiceLineID;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set info.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setInfo($value)
    {
        $this->info = $value;
        return $this;
    }

    /**
     * Get info.
     *
     * @return string
     */
    public function getInfo()
    {
        return $this->info;
    }

    /**
     * Set amount.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setAmount($value)
    {
        $this->amount = $value;
        return $this;
    }

    /**
     * Get amount.
     *
     * @return float
     */
    public function getAmount()
    {
        return $this->amount;
    }

    /**
     * Set numberOfTimes.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setNumberOfTimes($value)
    {
        $this->numberOfTimes = $value;
        return $this;
    }

    /**
     * Get numberOfTimes.
     *
     * @return float
     */
    public function getNumberOfTimes()
    {
        return $this->numberOfTimes;
    }

    /**
     * Set discountPercentage.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setDiscountPercentage($value)
    {
        $this->discountPercentage = $value;
        return $this;
    }

    /**
     * Get discountPercentage.
     *
     * @return float
     */
    public function getDiscountPercentage()
    {
        return $this->discountPercentage;
    }

    /**
     * Set total.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setTotal($value)
    {
        $this->total = $value;
        return $this;
    }

    /**
     * Get total.
     *
     * @return float
     */
    public function getTotal()
    {
        return $this->total;
    }

    /**
     * Set monNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setMonNumber($value)
    {
        $this->monNumber = $value;
        return $this;
    }

    /**
     * Get monNumber.
     *
     * @return float
     */
    public function getMonNumber()
    {
        return $this->monNumber;
    }

    /**
     * Set tueNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setTueNumber($value)
    {
        $this->tueNumber = $value;
        return $this;
    }

    /**
     * Get tueNumber.
     *
     * @return float
     */
    public function getTueNumber()
    {
        return $this->tueNumber;
    }

    /**
     * Set wedNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setWedNumber($value)
    {
        $this->wedNumber = $value;
        return $this;
    }

    /**
     * Get wedNumber.
     *
     * @return float
     */
    public function getWedNumber()
    {
        return $this->wedNumber;
    }

    /**
     * Set thuNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setThuNumber($value)
    {
        $this->thuNumber = $value;
        return $this;
    }

    /**
     * Get thuNumber.
     *
     * @return float
     */
    public function getThuNumber()
    {
        return $this->thuNumber;
    }

    /**
     * Set friNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setFriNumber($value)
    {
        $this->friNumber = $value;
        return $this;
    }

    /**
     * Get friNumber.
     *
     * @return float
     */
    public function getFriNumber()
    {
        return $this->friNumber;
    }

    /**
     * Set satNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setSatNumber($value)
    {
        $this->satNumber = $value;
        return $this;
    }

    /**
     * Get satNumber.
     *
     * @return float
     */
    public function getSatNumber()
    {
        return $this->satNumber;
    }

    /**
     * Set sunNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setSunNumber($value)
    {
        $this->sunNumber = $value;
        return $this;
    }

    /**
     * Get sunNumber.
     *
     * @return float
     */
    public function getSunNumber()
    {
        return $this->sunNumber;
    }

    /**
     * Set weekTotalNumber.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setWeekTotalNumber($value)
    {
        $this->weekTotalNumber = $value;
        return $this;
    }

    /**
     * Get weekTotalNumber.
     *
     * @return float
     */
    public function getWeekTotalNumber()
    {
        return $this->weekTotalNumber;
    }

    /**
     * Set unit.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setUnit($value)
    {
        $this->unit = $value;
        return $this;
    }

    /**
     * Get unit.
     *
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set invoicingDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setInvoicingDate($value)
    {
        $this->invoicingDate = $value;
        return $this;
    }

    /**
     * Get invoicingDate.
     *
     * @return string
     */
    public function getInvoicingDate()
    {
        return $this->invoicingDate;
    }

    /**
     * Set invoicingConditions.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setInvoicingConditions($value)
    {
        $this->invoicingConditions = $value;
        return $this;
    }

    /**
     * Get invoicingConditions.
     *
     * @return string
     */
    public function getInvoicingConditions()
    {
        return $this->invoicingConditions;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set serviceDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setServiceDate($value)
    {
        $this->serviceDate = $value;
        return $this;
    }

    /**
     * Get serviceDate.
     *
     * @return string
     */
    public function getServiceDate()
    {
        return $this->serviceDate;
    }

    /**
     * Set purchaseAmount.
     *
     * Provides a fluent interface.
     *
     * @param float $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setPurchaseAmount($value)
    {
        $this->purchaseAmount = $value;
        return $this;
    }

    /**
     * Get purchaseAmount.
     *
     * @return float
     */
    public function getPurchaseAmount()
    {
        return $this->purchaseAmount;
    }

    /**
     * Set showPurchaseInvoiceDetails.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setShowPurchaseInvoiceDetails($value)
    {
        $this->showPurchaseInvoiceDetails = $value;
        return $this;
    }

    /**
     * Get showPurchaseInvoiceDetails.
     *
     * @return integer
     */
    public function getShowPurchaseInvoiceDetails()
    {
        return $this->showPurchaseInvoiceDetails;
    }

    /**
     * Set purchaseNotes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setPurchaseNotes($value)
    {
        $this->purchaseNotes = $value;
        return $this;
    }

    /**
     * Get purchaseNotes.
     *
     * @return string
     */
    public function getPurchaseNotes()
    {
        return $this->purchaseNotes;
    }

    /**
     * Set purchaseDescription.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setPurchaseDescription($value)
    {
        $this->purchaseDescription = $value;
        return $this;
    }

    /**
     * Get purchaseDescription.
     *
     * @return string
     */
    public function getPurchaseDescription()
    {
        return $this->purchaseDescription;
    }

    /**
     * Set credited.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setCredited($value)
    {
        $this->credited = $value;
        return $this;
    }

    /**
     * Get credited.
     *
     * @return integer
     */
    public function getCredited()
    {
        return $this->credited;
    }

    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }

    /**
     * Set toWeekHour.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRWeekHour $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToWeekHour($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRWeekHour($value); 
        }                 
        $this->toWeekHour = $value;
        return $this;
    }

    /**
     * Get toWeekHour.
     *
     * @return Carerix_Api_Rest_Entity_CRWeekHour
     */
    public function getToWeekHour()
    {
        return $this->toWeekHour;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set toInvoice.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRInvoice $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToInvoice($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRInvoice($value); 
        }                 
        $this->toInvoice = $value;
        return $this;
    }

    /**
     * Get toInvoice.
     *
     * @return Carerix_Api_Rest_Entity_CRInvoice
     */
    public function getToInvoice()
    {
        return $this->toInvoice;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set toServiceNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToServiceNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toServiceNode = $value;
        return $this;
    }

    /**
     * Get toServiceNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToServiceNode()
    {
        return $this->toServiceNode;
    }

    /**
     * Set toCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToCurrencyNode()
    {
        return $this->toCurrencyNode;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRVacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRVacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_CRVacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set toPublication.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRPublication $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToPublication($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRPublication($value); 
        }                 
        $this->toPublication = $value;
        return $this;
    }

    /**
     * Get toPublication.
     *
     * @return Carerix_Api_Rest_Entity_CRPublication
     */
    public function getToPublication()
    {
        return $this->toPublication;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAttachment'); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAttachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }

    /**
     * Set toJob.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRJob $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToJob($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRJob($value); 
        }                 
        $this->toJob = $value;
        return $this;
    }

    /**
     * Get toJob.
     *
     * @return Carerix_Api_Rest_Entity_CRJob
     */
    public function getToJob()
    {
        return $this->toJob;
    }

    /**
     * Set todos.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setTodos($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRToDo'); 
        } 
        $this->todos = $values;
        return $this;
    }

    /**
     * Get todos.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRToDo
     */
    public function getTodos($index = null)
    {
        if($index !== null) {
            return $this->todos[$index];
        }
        return $this->todos;
    }

    /**
     * Set toWeekHourJobView.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRWeekHourJobView $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToWeekHourJobView($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRWeekHourJobView($value); 
        }                 
        $this->toWeekHourJobView = $value;
        return $this;
    }

    /**
     * Get toWeekHourJobView.
     *
     * @return Carerix_Api_Rest_Entity_CRWeekHourJobView
     */
    public function getToWeekHourJobView()
    {
        return $this->toWeekHourJobView;
    }

    /**
     * Set toEmployee.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CREmployee $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToEmployee($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CREmployee($value); 
        }                 
        $this->toEmployee = $value;
        return $this;
    }

    /**
     * Get toEmployee.
     *
     * @return Carerix_Api_Rest_Entity_CREmployee
     */
    public function getToEmployee()
    {
        return $this->toEmployee;
    }

    /**
     * Set toToDo.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRToDo $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToToDo($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRToDo($value); 
        }                 
        $this->toToDo = $value;
        return $this;
    }

    /**
     * Get toToDo.
     *
     * @return Carerix_Api_Rest_Entity_CRToDo
     */
    public function getToToDo()
    {
        return $this->toToDo;
    }

    /**
     * Set toCompany.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRCompany $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToCompany($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRCompany($value); 
        }                 
        $this->toCompany = $value;
        return $this;
    }

    /**
     * Get toCompany.
     *
     * @return Carerix_Api_Rest_Entity_CRCompany
     */
    public function getToCompany()
    {
        return $this->toCompany;
    }

    /**
     * Set toInvoicingConditionNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToInvoicingConditionNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toInvoicingConditionNode = $value;
        return $this;
    }

    /**
     * Get toInvoicingConditionNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToInvoicingConditionNode()
    {
        return $this->toInvoicingConditionNode;
    }

    /**
     * Set purchaseInvoices.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setPurchaseInvoices($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRPurchaseInvoice'); 
        } 
        $this->purchaseInvoices = $values;
        return $this;
    }

    /**
     * Get purchaseInvoices.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRPurchaseInvoice
     */
    public function getPurchaseInvoices($index = null)
    {
        if($index !== null) {
            return $this->purchaseInvoices[$index];
        }
        return $this->purchaseInvoices;
    }

    /**
     * Set toSupplier.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRCompany $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToSupplier($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRCompany($value); 
        }                 
        $this->toSupplier = $value;
        return $this;
    }

    /**
     * Get toSupplier.
     *
     * @return Carerix_Api_Rest_Entity_CRCompany
     */
    public function getToSupplier()
    {
        return $this->toSupplier;
    }

    /**
     * Set toSupplierContact.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToSupplierContact($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->toSupplierContact = $value;
        return $this;
    }

    /**
     * Get toSupplierContact.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getToSupplierContact()
    {
        return $this->toSupplierContact;
    }

    /**
     * Set toPurchaseCurrencyNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToPurchaseCurrencyNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toPurchaseCurrencyNode = $value;
        return $this;
    }

    /**
     * Get toPurchaseCurrencyNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToPurchaseCurrencyNode()
    {
        return $this->toPurchaseCurrencyNode;
    }

    /**
     * Set toFinance.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRFinance $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToFinance($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRFinance($value); 
        }                 
        $this->toFinance = $value;
        return $this;
    }

    /**
     * Get toFinance.
     *
     * @return Carerix_Api_Rest_Entity_CRFinance
     */
    public function getToFinance()
    {
        return $this->toFinance;
    }

    /**
     * Set toCreditInvoiceLine.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRInvoiceLine $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRInvoiceLine
     */
    public function setToCreditInvoiceLine($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRInvoiceLine($value); 
        }                 
        $this->toCreditInvoiceLine = $value;
        return $this;
    }

    /**
     * Get toCreditInvoiceLine.
     *
     * @return Carerix_Api_Rest_Entity_CRInvoiceLine
     */
    public function getToCreditInvoiceLine()
    {
        return $this->toCreditInvoiceLine;
    }


}