<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-04-23 12:12:12Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 29 Sep 2011 19:15:10 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $weekMondayDate = null;

    /**
     * @access private
     * @var float
     * @value-class NSDecimalNumber
     * @allows-null 0
     */
    public $hoursTotal = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value-class NSCalendarDate
     * @allows-null 0
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRJob
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRJob")
     * @mandatory 0
     * @destination-entity CRJob
     * @to-many 0
     * @name toJob
     */
    public $toJob = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CREmployee
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CREmployee")
     * @mandatory 0
     * @destination-entity CREmployee
     * @to-many 0
     * @name toEmployee
     */
    public $toEmployee = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRWeekHour")
     * @mandatory 0
     * @destination-entity CRWeekHour
     * @to-many 1
     * @name allWeekHours
     */
    public $allWeekHours = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRWeekHourView
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRWeekHourView")
     * @mandatory 0
     * @destination-entity CRWeekHourView
     * @to-many 0
     * @name toWeekHourView
     */
    public $toWeekHourView = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRAttachment")
     * @mandatory 0
     * @destination-entity CRAttachment
     * @to-many 1
     * @name attachments
     */
    public $attachments = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("weekHourJobViewID");
        $entityConfiguration->setName("CRWeekHourJobView");
    }

    /**
     * Set weekMondayDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setWeekMondayDate($value)
    {
        $this->weekMondayDate = $value;
        return $this;
    }

    /**
     * Get weekMondayDate.
     *
     * @return string
     */
    public function getWeekMondayDate()
    {
        return $this->weekMondayDate;
    }

    /**
     * Set hoursTotal.
     *
     * Provides a fluent interface.
     *
     * @param float $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setHoursTotal($value)
    {
        $this->hoursTotal = $value;
        return $this;
    }

    /**
     * Get hoursTotal.
     *
     * @return float
     */
    public function getHoursTotal()
    {
        return $this->hoursTotal;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set toJob.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRJob $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setToJob($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRJob($value); 
        }                 
        $this->toJob = $value;
        return $this;
    }

    /**
     * Get toJob.
     *
     * @return Carerix_Api_Rest_Entity_CRJob
     */
    public function getToJob()
    {
        return $this->toJob;
    }

    /**
     * Set toEmployee.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CREmployee $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setToEmployee($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CREmployee($value); 
        }                 
        $this->toEmployee = $value;
        return $this;
    }

    /**
     * Get toEmployee.
     *
     * @return Carerix_Api_Rest_Entity_CREmployee
     */
    public function getToEmployee()
    {
        return $this->toEmployee;
    }

    /**
     * Set allWeekHours.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setAllWeekHours($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRWeekHour'); 
        } 
        $this->allWeekHours = $values;
        return $this;
    }

    /**
     * Get allWeekHours.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRWeekHour
     */
    public function getAllWeekHours($index = null)
    {
        if($index !== null) {
            return $this->allWeekHours[$index];
        }
        return $this->allWeekHours;
    }

    /**
     * Set toWeekHourView.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRWeekHourView $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setToWeekHourView($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRWeekHourView($value); 
        }                 
        $this->toWeekHourView = $value;
        return $this;
    }

    /**
     * Get toWeekHourView.
     *
     * @return Carerix_Api_Rest_Entity_CRWeekHourView
     */
    public function getToWeekHourView()
    {
        return $this->toWeekHourView;
    }

    /**
     * Set attachments.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRWeekHourJobView
     */
    public function setAttachments($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRAttachment'); 
        } 
        $this->attachments = $values;
        return $this;
    }

    /**
     * Get attachments.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRAttachment
     */
    public function getAttachments($index = null)
    {
        if($index !== null) {
            return $this->attachments[$index];
        }
        return $this->attachments;
    }


}